diff --git a/gnome-session/gsm-manager.c b/gnome-session/gsm-manager.c
index b7f1788e..743a372e 100644
--- a/gnome-session/gsm-manager.c
+++ b/gnome-session/gsm-manager.c
@@ -367,49 +861,68 @@ complete_end_session_tasks (GsmManager *manager)
                     g_task_return_boolean (task, TRUE);
         }
 
-        g_slist_free_full (manager->pending_end_session_tasks,
+        g_slist_free_full (priv->pending_end_session_tasks,
                            (GDestroyNotify) g_object_unref);
-        manager->pending_end_session_tasks = NULL;
+        priv->pending_end_session_tasks = NULL;
 }
 
-static gboolean
-on_end_session_timeout (GsmManager *manager)
+static void
+do_phase_end_session (GsmManager *manager)
 {
-        manager->phase_timeout_id = 0;
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        ClientEndSessionData data;
 
-        for (GSList *l = manager->query_clients; l != NULL; l = l->next) {
-                g_warning ("Client '%s' failed to reply before timeout",
-                           gsm_client_peek_id (l->data));
+        complete_end_session_tasks (manager);
+
+        data.manager = manager;
+        data.flags = 0;
+
+        if (priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
+                data.flags |= GSM_CLIENT_END_SESSION_FLAG_FORCEFUL;
         }
 
-        end_phase (manager);
-        return FALSE;
+        if (priv->phase_timeout_id > 0) {
+                g_source_remove (priv->phase_timeout_id);
+                priv->phase_timeout_id = 0;
+        }
+
+        if (gsm_store_size (priv->clients) > 0) {
+                priv->phase_timeout_id = g_timeout_add_seconds (GSM_MANAGER_PHASE_TIMEOUT,
+                                                                         (GSourceFunc)on_phase_timeout,
+                                                                         manager);
+
+                gsm_store_foreach (priv->clients,
+                                   (GsmStoreFunc)_client_end_session_helper,
+                                   &data);
+        } else {
+                end_phase (manager);
+        }
 }
 
 static void
-do_phase_end_session (GsmManager *manager)
+do_phase_end_session_part_2 (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         ClientEndSessionData data;
 
-        complete_end_session_tasks (manager);
-
         data.manager = manager;
-        data.flags = GSM_CLIENT_END_SESSION_FLAG_NONE;
+        data.flags = 0;
 
-        if (manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
+        if (priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
                 data.flags |= GSM_CLIENT_END_SESSION_FLAG_FORCEFUL;
         }
+        data.flags |= GSM_CLIENT_END_SESSION_FLAG_LAST;
 
-        g_clear_handle_id (&manager->phase_timeout_id, g_source_remove);
+        /* keep the timeout that was started at the beginning of the
+         * GSM_MANAGER_PHASE_END_SESSION phase */
 
-        if (gsm_store_size (manager->clients) > 0) {
-                manager->phase_timeout_id = g_timeout_add_seconds (10,
-                                                                   (GSourceFunc)on_end_session_timeout,
-                                                                   manager);
+        if (g_slist_length (priv->next_query_clients) > 0) {
+                g_slist_foreach (priv->next_query_clients,
+                                 (GFunc)_client_end_session,
+                                 &data);
 
-                gsm_store_foreach (manager->clients,
-                                   (GsmStoreFunc)_client_end_session,
-                                   &data);
+                g_slist_free (priv->next_query_clients);
+                priv->next_query_clients = NULL;
         } else {
                 end_phase (manager);
         }
@@ -436,15 +949,53 @@ _client_stop (const char *id,
         return FALSE;
 }
 
+static void
+maybe_restart_user_bus (GsmManager *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GsmSystem *system;
+        g_autoptr(GVariant) reply = NULL;
+        g_autoptr(GError) error = NULL;
+
+        if (priv->dbus_disconnected)
+                return;
+
+        system = gsm_get_system ();
+
+        if (!gsm_system_is_last_session_for_user (system))
+                return;
+
+        reply = g_dbus_connection_call_sync (priv->connection,
+                                             "org.freedesktop.systemd1",
+                                             "/org/freedesktop/systemd1",
+                                             "org.freedesktop.systemd1.Manager",
+                                             "StopUnit",
+                                             g_variant_new ("(ss)", "dbus.service", "fail"),
+                                             NULL,
+                                             G_DBUS_CALL_FLAGS_NONE,
+                                             -1,
+                                             NULL,
+                                             &error);
+
+        if (error != NULL) {
+                g_debug ("GsmManager: reloading user bus failed: %s", error->message);
+        }
+}
+
 static void
 do_phase_exit (GsmManager *manager)
 {
-        if (gsm_store_size (manager->clients) > 0) {
-                gsm_store_foreach (manager->clients,
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (gsm_store_size (priv->clients) > 0) {
+                gsm_store_foreach (priv->clients,
                                    (GsmStoreFunc)_client_stop,
                                    NULL);
         }
 
+        if (!priv->systemd_managed)
+                maybe_restart_user_bus (manager);
+
         end_phase (manager);
 }
 
@@ -453,6 +1004,7 @@ _client_query_end_session (const char           *id,
                            GsmClient            *client,
                            ClientEndSessionData *data)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (data->manager);
         gboolean ret;
         GError  *error;
 
@@ -468,7 +1020,7 @@ _client_query_end_session (const char           *id,
                 /* FIXME: what should we do if we can't communicate with client? */
         } else {
                 g_debug ("GsmManager: adding client to query clients: %s", gsm_client_peek_id (client));
-                data->manager->query_clients = g_slist_prepend (data->manager->query_clients, client);
+                priv->query_clients = g_slist_prepend (priv->query_clients, client);
         }
 
         return FALSE;
@@ -492,17 +1044,18 @@ inhibitor_has_flag (gpointer      key,
 static gboolean
 gsm_manager_is_logout_inhibited (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitor *inhibitor;
 
-        if (manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
+        if (priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
                 return FALSE;
         }
 
-        if (manager->inhibitors == NULL) {
+        if (priv->inhibitors == NULL) {
                 return FALSE;
         }
 
-        inhibitor = (GsmInhibitor *)gsm_store_find (manager->inhibitors,
+        inhibitor = (GsmInhibitor *)gsm_store_find (priv->inhibitors,
                                                     (GsmStoreFunc)inhibitor_has_flag,
                                                     GUINT_TO_POINTER (GSM_INHIBITOR_FLAG_LOGOUT));
         if (inhibitor == NULL) {
@@ -514,13 +1067,14 @@ gsm_manager_is_logout_inhibited (GsmManager *manager)
 static gboolean
 gsm_manager_is_idle_inhibited (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitor *inhibitor;
 
-        if (manager->inhibitors == NULL) {
+        if (priv->inhibitors == NULL) {
                 return FALSE;
         }
 
-        inhibitor = (GsmInhibitor *)gsm_store_find (manager->inhibitors,
+        inhibitor = (GsmInhibitor *)gsm_store_find (priv->inhibitors,
                                                     (GsmStoreFunc)inhibitor_has_flag,
                                                     GUINT_TO_POINTER (GSM_INHIBITOR_FLAG_IDLE));
         if (inhibitor == NULL) {
@@ -565,27 +1119,29 @@ inhibitor_is_jit (gpointer      key,
 static void
 cancel_end_session (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         /* just ignore if received outside of shutdown */
-        if (manager->phase < GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+        if (priv->phase < GSM_MANAGER_PHASE_QUERY_END_SESSION) {
                 return;
         }
 
         /* switch back to running phase */
         g_debug ("GsmManager: Cancelling the end of session");
 
-        g_cancellable_cancel (manager->end_session_cancellable);
+        g_cancellable_cancel (priv->end_session_cancellable);
 
         gsm_manager_set_phase (manager, GSM_MANAGER_PHASE_RUNNING);
-        manager->logout_mode = GSM_MANAGER_LOGOUT_MODE_NORMAL;
+        priv->logout_mode = GSM_MANAGER_LOGOUT_MODE_NORMAL;
 
-        manager->logout_type = GSM_MANAGER_LOGOUT_NONE;
+        priv->logout_type = GSM_MANAGER_LOGOUT_NONE;
 
         /* clear all JIT inhibitors */
-        gsm_store_foreach_remove (manager->inhibitors,
+        gsm_store_foreach_remove (priv->inhibitors,
                                   (GsmStoreFunc)inhibitor_is_jit,
                                   (gpointer)manager);
 
-        gsm_store_foreach (manager->clients,
+        gsm_store_foreach (priv->clients,
                            (GsmStoreFunc)_client_cancel_end_session,
                            NULL);
 
@@ -595,32 +1151,35 @@ cancel_end_session (GsmManager *manager)
 static void
 end_session_or_show_shell_dialog (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         gboolean logout_prompt;
         GsmShellEndSessionDialogType type;
         gboolean logout_inhibited;
 
-        switch (manager->logout_type) {
+        switch (priv->logout_type) {
         case GSM_MANAGER_LOGOUT_LOGOUT:
                 type = GSM_SHELL_END_SESSION_DIALOG_TYPE_LOGOUT;
                 break;
         case GSM_MANAGER_LOGOUT_REBOOT:
+        case GSM_MANAGER_LOGOUT_REBOOT_INTERACT:
                 type = GSM_SHELL_END_SESSION_DIALOG_TYPE_RESTART;
                 break;
         case GSM_MANAGER_LOGOUT_SHUTDOWN:
+        case GSM_MANAGER_LOGOUT_SHUTDOWN_INTERACT:
                 type = GSM_SHELL_END_SESSION_DIALOG_TYPE_SHUTDOWN;
                 break;
         default:
                 g_warning ("Unexpected logout type %d when creating end session dialog",
-                           manager->logout_type);
+                           priv->logout_type);
                 type = GSM_SHELL_END_SESSION_DIALOG_TYPE_LOGOUT;
                 break;
         }
 
         logout_inhibited = gsm_manager_is_logout_inhibited (manager);
-        logout_prompt = g_settings_get_boolean (manager->settings,
+        logout_prompt = g_settings_get_boolean (priv->settings,
                                                 KEY_LOGOUT_PROMPT);
 
-        switch (manager->logout_mode) {
+        switch (priv->logout_mode) {
         case GSM_MANAGER_LOGOUT_MODE_NORMAL:
                 if (logout_inhibited || logout_prompt) {
                         show_shell_end_session_dialog (manager, type);
@@ -650,11 +1209,16 @@ end_session_or_show_shell_dialog (GsmManager *manager)
 static void
 query_end_session_complete (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: query end session complete");
 
         /* Remove the timeout since this can be called from outside the timer
          * and we don't want to have it called twice */
-        g_clear_handle_id (&manager->phase_timeout_id, g_source_remove);
+        if (priv->query_timeout_id > 0) {
+                g_source_remove (priv->query_timeout_id);
+                priv->query_timeout_id = 0;
+        }
 
         end_session_or_show_shell_dialog (manager);
 }
@@ -672,11 +1236,12 @@ generate_cookie (void)
 static guint32
 _generate_unique_cookie (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         guint32 cookie;
 
         do {
                 cookie = generate_cookie ();
-        } while (gsm_store_find (manager->inhibitors, (GsmStoreFunc)_find_by_cookie, &cookie) != NULL);
+        } while (gsm_store_find (priv->inhibitors, (GsmStoreFunc)_find_by_cookie, &cookie) != NULL);
 
         return cookie;
 }
@@ -684,37 +1249,56 @@ _generate_unique_cookie (GsmManager *manager)
 static gboolean
 _on_query_end_session_timeout (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GSList *l;
 
-        manager->phase_timeout_id = 0;
+        priv->query_timeout_id = 0;
 
         g_debug ("GsmManager: query end session timed out");
 
-        for (l = manager->query_clients; l != NULL; l = l->next) {
+        for (l = priv->query_clients; l != NULL; l = l->next) {
+                guint         cookie;
                 GsmInhibitor *inhibitor;
+                const char   *bus_name;
+                char         *app_id;
 
                 g_warning ("Client '%s' failed to reply before timeout",
                            gsm_client_peek_id (l->data));
 
                 /* Don't add "not responding" inhibitors if logout is forced
                  */
-                if (manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
+                if (priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
                         continue;
                 }
 
                 /* Add JIT inhibit for unresponsive client */
+                if (GSM_IS_DBUS_CLIENT (l->data)) {
+                        bus_name = gsm_dbus_client_get_bus_name (l->data);
+                } else {
+                        bus_name = NULL;
+                }
+
+                app_id = g_strdup (gsm_client_peek_app_id (l->data));
+                if (IS_STRING_EMPTY (app_id)) {
+                        /* XSMP clients don't give us an app id unless we start them */
+                        g_free (app_id);
+                        app_id = gsm_client_get_app_name (l->data);
+                }
+
+                cookie = _generate_unique_cookie (manager);
                 inhibitor = gsm_inhibitor_new_for_client (gsm_client_peek_id (l->data),
-                                                          gsm_client_peek_app_id (l->data),
+                                                          app_id,
                                                           GSM_INHIBITOR_FLAG_LOGOUT,
                                                           _("Not responding"),
-                                                          gsm_client_peek_bus_name (l->data),
-                                                          _generate_unique_cookie (manager));
-                gsm_store_add (manager->inhibitors, gsm_inhibitor_peek_id (inhibitor), G_OBJECT (inhibitor));
+                                                          bus_name,
+                                                          cookie);
+                g_free (app_id);
+                gsm_store_add (priv->inhibitors, gsm_inhibitor_peek_id (inhibitor), G_OBJECT (inhibitor));
                 g_object_unref (inhibitor);
         }
 
-        g_slist_free (manager->query_clients);
-        manager->query_clients = NULL;
+        g_slist_free (priv->query_clients);
+        priv->query_clients = NULL;
 
         query_end_session_complete (manager);
 
@@ -724,81 +1308,112 @@ _on_query_end_session_timeout (GsmManager *manager)
 static void
 do_phase_query_end_session (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         ClientEndSessionData data;
 
         data.manager = manager;
-        data.flags = GSM_CLIENT_END_SESSION_FLAG_NONE;
+        data.flags = 0;
 
-        if (manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
+        if (priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
                 data.flags |= GSM_CLIENT_END_SESSION_FLAG_FORCEFUL;
         }
+        /* We only query if an app is ready to log out, so we don't use
+         * GSM_CLIENT_END_SESSION_FLAG_SAVE here.
+         */
 
         debug_clients (manager);
         g_debug ("GsmManager: sending query-end-session to clients (logout mode: %s)",
-                 manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_NORMAL? "normal" :
-                 manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE? "forceful":
+                 priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_NORMAL? "normal" :
+                 priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE? "forceful":
                  "no confirmation");
-        gsm_store_foreach (manager->clients,
+        gsm_store_foreach (priv->clients,
                            (GsmStoreFunc)_client_query_end_session,
                            &data);
 
-        manager->phase_timeout_id = g_timeout_add_seconds (1, (GSourceFunc)_on_query_end_session_timeout, manager);
+        /* This phase doesn't time out unless logout is forced. Typically, this
+         * separate timer is only used to show UI. */
+        priv->query_timeout_id = g_timeout_add_seconds (1, (GSourceFunc)_on_query_end_session_timeout, manager);
 }
 
 static void
 update_idle (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         if (gsm_manager_is_idle_inhibited (manager)) {
-                gsm_presence_set_idle_enabled (manager->presence, FALSE);
+                gsm_presence_set_idle_enabled (priv->presence, FALSE);
         } else {
-                gsm_presence_set_idle_enabled (manager->presence, TRUE);
+                gsm_presence_set_idle_enabled (priv->presence, TRUE);
         }
 }
 
 static void
 start_phase (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: starting phase %s\n",
-                 phase_num_to_name (manager->phase));
+                 phase_num_to_name (priv->phase));
 
         /* reset state */
-        g_slist_free (manager->query_clients);
-        manager->query_clients = NULL;
+        g_slist_free (priv->pending_apps);
+        priv->pending_apps = NULL;
+        g_slist_free (priv->query_clients);
+        priv->query_clients = NULL;
+        g_slist_free (priv->next_query_clients);
+        priv->next_query_clients = NULL;
+
+        if (priv->query_timeout_id > 0) {
+                g_source_remove (priv->query_timeout_id);
+                priv->query_timeout_id = 0;
+        }
+        if (priv->phase_timeout_id > 0) {
+                g_source_remove (priv->phase_timeout_id);
+                priv->phase_timeout_id = 0;
+        }
 
-        g_clear_handle_id (&manager->phase_timeout_id, g_source_remove);
+        sd_notifyf (0, "STATUS=GNOME Session Manager phase is %s", phase_num_to_name (priv->phase));
 
-        switch (manager->phase) {
-        case GSM_MANAGER_PHASE_INITIALIZATION:
-                sd_notify (0, "READY=1\nSTATUS=Waiting for session to start");
+        switch (priv->phase) {
+        case GSM_MANAGER_PHASE_STARTUP:
+        case GSM_MANAGER_PHASE_EARLY_INITIALIZATION:
+        case GSM_MANAGER_PHASE_PRE_DISPLAY_SERVER:
+                do_phase_startup (manager);
                 break;
+        case GSM_MANAGER_PHASE_DISPLAY_SERVER:
+                sd_notify (0, "READY=1");
+                do_phase_startup (manager);
+                break;
+        case GSM_MANAGER_PHASE_INITIALIZATION:
+        case GSM_MANAGER_PHASE_WINDOW_MANAGER:
+        case GSM_MANAGER_PHASE_PANEL:
+        case GSM_MANAGER_PHASE_DESKTOP:
         case GSM_MANAGER_PHASE_APPLICATION:
-                sd_notify (0, "STATUS=Starting applications");
-                gsm_exported_manager_emit_session_running (manager->skeleton);
                 do_phase_startup (manager);
                 break;
         case GSM_MANAGER_PHASE_RUNNING:
-                sd_notify (0, "STATUS=Running");
                 sd_journal_send ("MESSAGE_ID=%s", GSM_MANAGER_STARTUP_SUCCEEDED_MSGID,
                                  "PRIORITY=%d", 5,
                                  "MESSAGE=Entering running state",
                                  NULL);
-                if (manager->pending_end_session_tasks != NULL)
+                if (priv->pending_end_session_tasks != NULL)
                         complete_end_session_tasks (manager);
-                g_object_unref (manager->end_session_cancellable);
-                manager->end_session_cancellable = g_cancellable_new ();
+                g_object_unref (priv->end_session_cancellable);
+                priv->end_session_cancellable = g_cancellable_new ();
+                gsm_exported_manager_emit_session_running (priv->skeleton);
                 update_idle (manager);
                 break;
         case GSM_MANAGER_PHASE_QUERY_END_SESSION:
-                sd_notify (0, "STATUS=Querying end of session");
                 do_phase_query_end_session (manager);
                 break;
         case GSM_MANAGER_PHASE_END_SESSION:
-                sd_notify (0, "STOPPING=1\nSTATUS=Logging out");
-                gsm_exported_manager_emit_session_over (manager->skeleton);
+                sd_notify (0, "STOPPING=1");
+
                 do_phase_end_session (manager);
                 break;
         case GSM_MANAGER_PHASE_EXIT:
-                sd_notify (0, "STOPPING=1\nSTATUS=Quitting");
+                sd_notify (0, "STOPPING=1");
+
                 do_phase_exit (manager);
                 break;
         default:
@@ -812,9 +1427,19 @@ _debug_app_for_phase (const char *id,
                       GsmApp     *app,
                       gpointer    data)
 {
-        g_debug ("GsmManager:\tapp-id:%s\tis-disabled:%d",
+        guint phase;
+
+        phase = GPOINTER_TO_UINT (data);
+
+        if (gsm_app_peek_phase (app) != phase) {
+                return FALSE;
+        }
+
+        g_debug ("GsmManager:\tID: %s\tapp-id:%s\tis-disabled:%d\tis-conditionally-disabled:%d",
+                 gsm_app_peek_id (app),
                  gsm_app_peek_app_id (app),
-                 gsm_app_peek_is_disabled (app));
+                 gsm_app_peek_is_disabled (app),
+                 gsm_app_peek_is_conditionally_disabled (app));
 
         return FALSE;
 }
@@ -822,32 +1447,80 @@ _debug_app_for_phase (const char *id,
 static void
 debug_app_summary (GsmManager *manager)
 {
-        g_debug ("GsmManager: Autostart app summary");
-        gsm_store_foreach (manager->apps,
-                           (GsmStoreFunc)_debug_app_for_phase,
-                           NULL);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        guint phase;
+
+        g_debug ("GsmManager: App startup summary");
+        for (phase = GSM_MANAGER_PHASE_EARLY_INITIALIZATION; phase < GSM_MANAGER_PHASE_RUNNING; phase++) {
+                g_debug ("GsmManager: Phase %s", phase_num_to_name (phase));
+                gsm_store_foreach (priv->apps,
+                                   (GsmStoreFunc)_debug_app_for_phase,
+                                   GUINT_TO_POINTER (phase));
+        }
 }
 
 void
 gsm_manager_start (GsmManager *manager)
 {
-        g_debug ("GsmManager: Starting");
+        g_debug ("GsmManager: GSM starting to manage");
 
         g_return_if_fail (GSM_IS_MANAGER (manager));
-        g_return_if_fail (manager->phase == GSM_MANAGER_PHASE_INITIALIZATION);
 
+        gsm_manager_set_phase (manager, GSM_MANAGER_PHASE_EARLY_INITIALIZATION);
         debug_app_summary (manager);
         start_phase (manager);
 }
 
+char *
+_gsm_manager_get_default_session (GsmManager     *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        g_autoptr(GSettings) session_settings = NULL;
+
+        if (manager)
+                session_settings = g_object_ref (priv->session_settings);
+        else
+                session_settings  = g_settings_new (SESSION_SCHEMA);
+        return g_settings_get_string (session_settings,
+                                      KEY_SESSION_NAME);
+}
+
 void
 _gsm_manager_set_active_session (GsmManager     *manager,
-                                 const char     *session_name)
+                                 const char     *session_name,
+                                 gboolean        is_fallback)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        g_free (priv->session_name);
+        priv->session_name = g_strdup (session_name);
+        priv->is_fallback_session = is_fallback;
+
+        gsm_exported_manager_set_session_name (priv->skeleton, session_name);
+}
+
+static gboolean
+_app_has_app_id (const char   *id,
+                 GsmApp       *app,
+                 const char   *app_id_a)
+{
+        const char *app_id_b;
+
+        app_id_b = gsm_app_peek_app_id (app);
+        return (app_id_b != NULL && strcmp (app_id_a, app_id_b) == 0);
+}
+
+static GsmApp *
+find_app_for_app_id (GsmManager *manager,
+                     const char *app_id)
 {
-        g_free (manager->session_name);
-        manager->session_name = g_strdup (session_name);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GsmApp *app;
 
-        gsm_exported_manager_set_session_name (manager->skeleton, session_name);
+        app = (GsmApp *)gsm_store_find (priv->apps,
+                                        (GsmStoreFunc)_app_has_app_id,
+                                        (char *)app_id);
+        return app;
 }
 
 static gboolean
@@ -873,23 +1546,109 @@ inhibitor_has_client_id (gpointer      key,
         return matches;
 }
 
+static gboolean
+_app_has_startup_id (const char *id,
+                     GsmApp     *app,
+                     const char *startup_id_a)
+{
+        const char *startup_id_b;
+
+        startup_id_b = gsm_app_peek_startup_id (app);
+
+        if (IS_STRING_EMPTY (startup_id_b)) {
+                return FALSE;
+        }
+
+        return (strcmp (startup_id_a, startup_id_b) == 0);
+}
+
+static GsmApp *
+find_app_for_startup_id (GsmManager *manager,
+                        const char *startup_id)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GsmApp *found_app;
+        GSList *a;
+
+        found_app = NULL;
+
+        /* If we're starting up the session, try to match the new client
+         * with one pending apps for the current phase. If not, try to match
+         * with any of the autostarted apps. */
+        if (priv->phase < GSM_MANAGER_PHASE_APPLICATION) {
+                for (a = priv->pending_apps; a != NULL; a = a->next) {
+                        GsmApp *app = GSM_APP (a->data);
+
+                        if (strcmp (startup_id, gsm_app_peek_startup_id (app)) == 0) {
+                                found_app = app;
+                                goto out;
+                        }
+                }
+        } else {
+                GsmApp *app;
+
+                app = (GsmApp *)gsm_store_find (priv->apps,
+                                                (GsmStoreFunc)_app_has_startup_id,
+                                                (char *)startup_id);
+                if (app != NULL) {
+                        found_app = app;
+                        goto out;
+                }
+        }
+ out:
+        return found_app;
+}
+
 static void
 _disconnect_client (GsmManager *manager,
                     GsmClient  *client)
 {
-        g_debug ("GsmManager: disconnect client: %s (app: %s)",
-                 gsm_client_peek_id (client),
-                 gsm_client_peek_app_id (client));
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        gboolean              is_condition_client;
+        GsmApp               *app;
+        const char           *app_id;
+        const char           *startup_id;
+        gboolean              app_restart;
+        GsmClientRestartStyle client_restart_hint;
+
+        g_debug ("GsmManager: disconnect client: %s", gsm_client_peek_id (client));
 
         /* take a ref so it doesn't get finalized */
         g_object_ref (client);
 
+        gsm_client_set_status (client, GSM_CLIENT_FINISHED);
+
+        is_condition_client = FALSE;
+        if (g_slist_find (priv->condition_clients, client)) {
+                priv->condition_clients = g_slist_remove (priv->condition_clients, client);
+
+                is_condition_client = TRUE;
+        }
+
         /* remove any inhibitors for this client */
-        gsm_store_foreach_remove (manager->inhibitors,
+        gsm_store_foreach_remove (priv->inhibitors,
                                   (GsmStoreFunc)inhibitor_has_client_id,
                                   (gpointer)gsm_client_peek_id (client));
 
-        switch (manager->phase) {
+        app = NULL;
+
+        /* first try to match on startup ID */
+        startup_id = gsm_client_peek_startup_id (client);
+        if (! IS_STRING_EMPTY (startup_id)) {
+                app = find_app_for_startup_id (manager, startup_id);
+
+        }
+
+        /* then try to find matching app-id */
+        if (app == NULL) {
+                app_id = gsm_client_peek_app_id (client);
+                if (! IS_STRING_EMPTY (app_id)) {
+                        g_debug ("GsmManager: disconnect for app '%s'", app_id);
+                        app = find_app_for_app_id (manager, app_id);
+                }
+        }
+
+        switch (priv->phase) {
         case GSM_MANAGER_PHASE_QUERY_END_SESSION:
                 /* Instead of answering our end session query, the client just exited.
                  * Treat that as an "okay, end the session" answer.
@@ -897,15 +1656,18 @@ _disconnect_client (GsmManager *manager,
                  * This call implicitly removes any inhibitors for the client, along
                  * with removing the client from the pending query list.
                  */
-                on_client_end_session_response (client,
-                                                TRUE,
-                                                "Client exited in query end "
-                                                "session phase instead of end "
-                                                "session phase",
-                                                manager);
+                _handle_client_end_session_response (manager,
+                                                     client,
+                                                     TRUE,
+                                                     FALSE,
+                                                     FALSE,
+                                                     "Client exited in "
+                                                     "query end session phase "
+                                                     "instead of end session "
+                                                     "phase");
                 break;
         case GSM_MANAGER_PHASE_END_SESSION:
-                if (! g_slist_find (manager->query_clients, client)) {
+                if (! g_slist_find (priv->query_clients, client)) {
                         /* the client sent its EndSessionResponse and we already
                          * processed it.
                          */
